#ifndef PSO_BEST_FUNCTIONS_H
#define PSO_BEST_FUNCTIONS_H

#include "pso.h"
#include "../nsga2/NSGA2_DEPSO.h"

int pso_ring_local_best_function(int population_size,int id,struct DEPSOPosition * pop,void * data);

int pso_global_best_function(int population_size,struct DEPSOPosition * pop,void * data);

int pso_star_local_best_function(int population_size,int id,struct DEPSOPosition * pop,void * data);

// see pso_meta_fitness_function.c for definition
extern PSO_GLOBAL_BEST_FUNCTION(const pso_global_best_functions[PSO_META_TOPOLOGY_COUNT]);
extern PSO_LOCAL_BEST_FUNCTION(const pso_local_best_functions[PSO_META_TOPOLOGY_COUNT]);

#endif // PSO_BEST_FUNCTIONS_H
