#include "random_subgroup.h"

#include "random.h"


int extract_random_index_except(int group_size,int exceptions_size,int * exceptions) {
    int i;

    int rand_int = alea_integer(0,group_size - exceptions_size - 1);
    for (i = 0; i < exceptions_size; i++)
        if (exceptions[i] <= rand_int)
            rand_int++;

    return rand_int;
}

void insert_index_ordered_asc(int group_size,int * group,int newmember) {
    int i;
    int temp,temptemp;

    // go to the first element >= than the current
    for (i = 0; i < group_size && newmember > group[i]; i++);

    // store the element
    temp = group[i];
    group[i] = newmember;

    // shift all the next elements
    for (i; i < group_size; i++) {
        temptemp = group[i + 1];
        group[i + 1] = temp;
        temp = temptemp;
    }
}
