#include "nsga2/random.h"

using namespace nsga2;

random_gen rgen; // global common random generator

random_gen::random_gen(uint32_t s) {
    seed = s;
    srand(seed);
} 

random_gen::~random_gen() {
}

double random_gen::realu() {
	return (float)rand() / (float)RAND_MAX;
}

double random_gen::real(double low, double high) { 
    return (low + (high-low)*realu());
}

int random_gen::integer(int low, int high) { 
    return (int)real(low, high);
}

void random_gen::set_seed(uint32_t s) {
    seed = s;
    srand(seed);
}

int random_gen::get_seed() const {
    return seed;
}
